package quickbi_public

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// QueryDataRange invokes the quickbi_public.QueryDataRange API synchronously
func (client *Client) QueryDataRange(request *QueryDataRangeRequest) (response *QueryDataRangeResponse, err error) {
	response = CreateQueryDataRangeResponse()
	err = client.DoAction(request, response)
	return
}

// QueryDataRangeWithChan invokes the quickbi_public.QueryDataRange API asynchronously
func (client *Client) QueryDataRangeWithChan(request *QueryDataRangeRequest) (<-chan *QueryDataRangeResponse, <-chan error) {
	responseChan := make(chan *QueryDataRangeResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.QueryDataRange(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// QueryDataRangeWithCallback invokes the quickbi_public.QueryDataRange API asynchronously
func (client *Client) QueryDataRangeWithCallback(request *QueryDataRangeRequest, callback func(response *QueryDataRangeResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *QueryDataRangeResponse
		var err error
		defer close(result)
		response, err = client.QueryDataRange(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// QueryDataRangeRequest is the request struct for api QueryDataRange
type QueryDataRangeRequest struct {
	*requests.RpcRequest
	AccessPoint string `position:"Query" name:"AccessPoint"`
	SignType    string `position:"Query" name:"SignType"`
	Type        string `position:"Query" name:"Type"`
	Keyword     string `position:"Query" name:"Keyword"`
}

// QueryDataRangeResponse is the response struct for api QueryDataRange
type QueryDataRangeResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Success   bool   `json:"Success" xml:"Success"`
	Result    Result `json:"Result" xml:"Result"`
}

// CreateQueryDataRangeRequest creates a request to invoke QueryDataRange API
func CreateQueryDataRangeRequest() (request *QueryDataRangeRequest) {
	request = &QueryDataRangeRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("quickbi-public", "2022-01-01", "QueryDataRange", "2.2.0", "openAPI")
	request.Method = requests.POST
	return
}

// CreateQueryDataRangeResponse creates a response to parse from QueryDataRange response
func CreateQueryDataRangeResponse() (response *QueryDataRangeResponse) {
	response = &QueryDataRangeResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
